Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -2906,406 +1862,165 @@
 ///////////////////////
 {
-    //////////////////
-    // DMA Commands //
-    //////////////////
+    // VCI initiator command on RAM network
+    // directly the content of the dma_cmd FIFO
+
+    p_vci_ini_ram.cmdval  = m_dma_cmd_addr_fifo.rok(); 
+    p_vci_ini_ram.address = m_dma_cmd_addr_fifo.read();
+    p_vci_ini_ram.be      = m_dma_cmd_be_fifo.read();
+    p_vci_ini_ram.cmd     = m_dma_cmd_cmd_fifo.read();
+    p_vci_ini_ram.contig  = m_dma_cmd_contig_fifo.read();
+    p_vci_ini_ram.wdata   = m_dma_cmd_data_fifo.read(); 
+    p_vci_ini_ram.eop     = m_dma_cmd_eop_fifo.read();
+    p_vci_ini_ram.cons    = m_dma_cmd_cons_fifo.read();
+    p_vci_ini_ram.plen    = m_dma_cmd_plen_fifo.read();
+    p_vci_ini_ram.wrap    = m_dma_cmd_wrap_fifo.read();
+    p_vci_ini_ram.cfixed  = m_dma_cmd_cfixed_fifo.read();
+    p_vci_ini_ram.clen    = m_dma_cmd_clen_fifo.read();
+    p_vci_ini_ram.trdid   = m_dma_cmd_trdid_fifo.read();
+    p_vci_ini_ram.pktid   = m_dma_cmd_pktid_fifo.read();
+    p_vci_ini_ram.srcid   = m_dma_cmd_srcid_fifo.read();
     
-    // VCI initiator command on the xram network
-    if(m_dma_cmd_addr_fifo.rok()) 
-    //&& p_vci_ini_dma.cmdack.read())
-    {
-        p_vci_ini_dma.cmdval  = true;
-        #if NEW_XRAM_VCI
-        p_vci_ini_dma.address = (paddr_t_x)(m_dma_cmd_addr_fifo.read() >> 6 )
-        #else
-        p_vci_ini_dma.address = m_dma_cmd_addr_fifo.read();
-        #endif
-        
-        p_vci_ini_dma.be      = m_dma_cmd_be_fifo.read();
-        p_vci_ini_dma.cmd     = m_dma_cmd_cmd_fifo.read();
-        p_vci_ini_dma.contig  = m_dma_cmd_contig_fifo.read();
-        #if NEW_XRAM_VCI
-        //TODO for 64 bits field
-        #else
-        p_vci_ini_dma.wdata   = m_dma_cmd_data_fifo.read(); // The first is in param_x
-                                                    // the second in param_io
-        #endif
-        p_vci_ini_dma.eop     = m_dma_cmd_eop_fifo.read();
-        p_vci_ini_dma.cons    = m_dma_cmd_cons_fifo.read();
-        p_vci_ini_dma.plen    = m_dma_cmd_plen_fifo.read();
-        p_vci_ini_dma.wrap    = m_dma_cmd_wrap_fifo.read();
-        p_vci_ini_dma.cfixed  = m_dma_cmd_cfixed_fifo.read();
-        p_vci_ini_dma.clen    = m_dma_cmd_clen_fifo.read();
-        p_vci_ini_dma.trdid   = m_dma_cmd_trdid_fifo.read();
-        p_vci_ini_dma.pktid   = m_dma_cmd_pktid_fifo.read();
-        p_vci_ini_dma.srcid   = m_dma_cmd_srcid_fifo.read();
-    }
-    else
-    {
-        p_vci_ini_dma.cmdval  = false;
-        p_vci_ini_dma.address = 0;
-        p_vci_ini_dma.be      = 0;
-        p_vci_ini_dma.cmd     = vci_param_x::CMD_NOP;
-        p_vci_ini_dma.contig  = false;
-        p_vci_ini_dma.wdata   = 0;
-        p_vci_ini_dma.eop     = false;
-        p_vci_ini_dma.cons    = true;
-        p_vci_ini_dma.plen    = 0;
-        p_vci_ini_dma.wrap    = false;
-        p_vci_ini_dma.cfixed  = false;
-        p_vci_ini_dma.clen    = 0;
-        p_vci_ini_dma.trdid   = 0;
-        p_vci_ini_dma.pktid   = 0; 
-    }
-    
-    // VCI target command on the IO network
-    // it depends on the DMA_CMD FSM state
+    // VCI target command ack on IOX network
+    // depends on the DMA_CMD FSM state
 
     switch ( r_dma_cmd_fsm.read() ) 
     {
     case DMA_CMD_IDLE:
-    case DMA_CMD_TRT_LOCK:	
-    case DMA_CMD_TRT_WAIT:	
-    case DMA_CMD_TRT_SET:	
-        p_vci_tgt_dma.cmdack  = false;
-        break;
-    case DMA_CMD_FIFO_PUT:
-    case DMA_CMD_FIFO_MISS_PUT:
-        p_vci_tgt_dma.cmdack  = m_dma_cmd_addr_fifo.wok();
-        break;
-    case DMA_CMD_TLB_MISS_WAIT:
-        p_vci_tgt_dma.cmdack  = false;
-        break;
-    case DMA_CMD_TLB_MISS_STORE:
-        p_vci_tgt_dma.cmdack  = true;
-        break;
-    case DMA_CMD_ERROR:
-        p_vci_tgt_dma.cmdack  = !r_dma_cmd_error_req.read();
+    case DMA_CMD_MISS_WAIT:
+        p_vci_tgt_iox.cmdack  = false;
+        break;
+    case DMA_CMD_WAIT_EOP:
+        p_vci_tgt_iox.cmdack  = true;
+        break;
+    case DMA_CMD_FIFO_PUT_CMD:
+        p_vci_tgt_iox.cmdack  = m_dma_cmd_addr_fifo.wok();
+        break;
+    case DMA_CMD_FIFO_PUT_RSP:
+        p_vci_tgt_iox.cmdack  = m_dma_rsp_data_fifo.wok();
         break; 
     }// end switch r_dma_cmd_fsm
 
-    //////////////////
-    // DMA Responses//
-    //////////////////
+    // VCI target response on IOX network
+    // directly the content of the DMA_RSP FIFO
+
+    p_vci_tgt_iox.rspval  = m_dma_rsp_data_fifo.rok();
+    p_vci_tgt_iox.rsrcid  = m_dma_rsp_rsrcid_fifo.read();
+    p_vci_tgt_iox.rtrdid  = m_dma_rsp_rtrdid_fifo.read();
+    p_vci_tgt_iox.rpktid  = m_dma_rsp_rpktid_fifo.read();
+    p_vci_tgt_iox.rdata   = m_dma_rsp_data_fifo.read(); 
+    p_vci_tgt_iox.rerror  = m_dma_rsp_rerror_fifo.read();
+    p_vci_tgt_iox.reop    = m_dma_rsp_reop_fifo.read();
+
+    // VCI initiator response on the RAM Network
+    // depends on the DMA_RSP FSM state
+
+   	p_vci_ini_ram.rspack = m_dma_rsp_data_fifo.wok() and
+                           (r_dma_rsp_fsm.read() == DMA_RSP_FIFO_PUT) and 
+                           not r_alloc_fifo_dma_rsp_local.read();
+
+    // VCI initiator command on IOX network
+    // directly the content of the CONFIG_CMD FIFO
+
+    p_vci_ini_iox.cmdval  = m_config_cmd_addr_fifo.rok();
+    p_vci_ini_iox.address = m_config_cmd_addr_fifo.read();
+    p_vci_ini_iox.be      = m_config_cmd_be_fifo.read();
+    p_vci_ini_iox.cmd     = m_config_cmd_cmd_fifo.read();
+    p_vci_ini_iox.contig  = m_config_cmd_contig_fifo.read();
+    p_vci_ini_iox.wdata   = (ext_data_t)m_config_cmd_data_fifo.read(); 
+    p_vci_ini_iox.eop     = m_config_cmd_eop_fifo.read();
+    p_vci_ini_iox.cons    = m_config_cmd_cons_fifo.read();
+    p_vci_ini_iox.plen    = m_config_cmd_plen_fifo.read();
+    p_vci_ini_iox.wrap    = m_config_cmd_wrap_fifo.read();
+    p_vci_ini_iox.cfixed  = m_config_cmd_cfixed_fifo.read();
+    p_vci_ini_iox.clen    = m_config_cmd_clen_fifo.read();
+    p_vci_ini_iox.trdid   = m_config_cmd_trdid_fifo.read();
+    p_vci_ini_iox.pktid   = m_config_cmd_pktid_fifo.read();
+    p_vci_ini_iox.srcid   = m_config_cmd_srcid_fifo.read();
     
-    // VCI target response on the IO network
-    if(m_dma_rsp_data_fifo.rok())
-    {
-        p_vci_tgt_dma.rspval  = true;
-		p_vci_tgt_dma.rsrcid  = m_dma_rsp_rsrcid_fifo.read();
-        p_vci_tgt_dma.rtrdid  = m_dma_rsp_rtrdid_fifo.read();
-        
-        p_vci_tgt_dma.rpktid  = m_dma_rsp_rpktid_fifo.read();
+    // VCI target command ack on INT network
+    // it depends on the CONFIG_CMD FSM state
+
+    switch ( r_config_cmd_fsm.read() ) 
+    {
+    case CONFIG_CMD_IDLE:
+        p_vci_tgt_int.cmdack  = false;
+        break;
+    case CONFIG_CMD_FIFO_PUT_CMD:	  
+        p_vci_tgt_int.cmdack  = m_config_cmd_addr_fifo.wok();
+        break;
+    case CONFIG_CMD_FIFO_PUT_RSP:	  
+        p_vci_tgt_int.cmdack  = m_config_rsp_data_fifo.wok() and 
+                                r_alloc_fifo_config_rsp_local.read();
+        break;
+    }// end switch r_config_cmd_fsm
+
+    // VCI target response on INT network
+    // directly the content of the CONFIG_RSP FIFO
+
+    p_vci_tgt_int.rspval  = m_config_rsp_data_fifo.rok();
+	p_vci_tgt_int.rsrcid  = m_config_rsp_rsrcid_fifo.read();
+    p_vci_tgt_int.rtrdid  = m_config_rsp_rtrdid_fifo.read();
+    p_vci_tgt_int.rpktid  = m_config_rsp_rpktid_fifo.read();
+    p_vci_tgt_int.rdata   = m_config_rsp_data_fifo.read();
+    p_vci_tgt_int.rerror  = m_config_rsp_rerror_fifo.read();
+    p_vci_tgt_int.reop    = m_config_rsp_reop_fifo.read();
     
-        #if NEW_XRAM_VCI
-        //TODO for 64 bit data field
-        #else 
-        p_vci_tgt_dma.rdata   = m_dma_rsp_data_fifo.read(); // The first is in param_io
-                                                    // the second in param_x
-        #endif 
-        
-        p_vci_tgt_dma.rerror  = m_dma_rsp_rerror_fifo.read();
-        p_vci_tgt_dma.reop    = m_dma_rsp_reop_fifo.read();
-    }
-    else
-    {
-        p_vci_tgt_dma.rspval  = false;
-        
-		p_vci_tgt_dma.rsrcid  = 0;
-		p_vci_tgt_dma.rdata   = 0;
-		p_vci_tgt_dma.rpktid  = 0;
-		p_vci_tgt_dma.rtrdid  = 0;
-		p_vci_tgt_dma.rerror  = 0;
-		p_vci_tgt_dma.reop    = false;
-
-    }
-
-    // VCI initiator response on the Xram Network
-    // it depends on the DMA_RSP FSM state
-    switch ( r_dma_rsp_fsm.read() ) 
-    {
-    case DMA_RSP_IDLE:
-    case DMA_RSP_TRT_LOCK:
-    case DMA_RSP_FIFO_ERROR_PUT:
-    {
-		p_vci_ini_dma.rspack = false;
-        break;
-    }
-    case DMA_RSP_FIFO_PUT:
-	{
-    	p_vci_ini_dma.rspack = m_dma_rsp_data_fifo.wok();
-        break;
-    }
-    }// end switch r_dma_rsp_fsm
-
-    /////////////////////
-    // CONFIG Commands //
-    /////////////////////
-
-    // VCI initiator command on the IO network
-    if(m_config_cmd_addr_fifo.rok())
-    {
-        p_vci_ini_config.cmdval  = true;
-        #if NEW_XRAM_VCI
-        p_vci_ini_config.address = (paddr_t_x)(m_config_cmd_addr_fifo.read() >> 6 )
-        #else
-        p_vci_ini_config.address = m_config_cmd_addr_fifo.read();
-        #endif
-        
-        p_vci_ini_config.be      = (vci_be_t_x)m_config_cmd_be_fifo.read();
-        p_vci_ini_config.cmd     = m_config_cmd_cmd_fifo.read();
-        p_vci_ini_config.contig  = m_config_cmd_contig_fifo.read();
-        #if NEW_XRAM_VCI
-        //TODO
-        #else
-        p_vci_ini_config.wdata   = (vci_data_t_x)m_config_cmd_data_fifo.read(); // The first is in param_io
-                                                    // the second in param_d
-        #endif
-        p_vci_ini_config.eop     = m_config_cmd_eop_fifo.read();
-        p_vci_ini_config.cons    = m_config_cmd_cons_fifo.read();
-        p_vci_ini_config.plen    = m_config_cmd_plen_fifo.read();
-        p_vci_ini_config.wrap    = m_config_cmd_wrap_fifo.read();
-        p_vci_ini_config.cfixed  = m_config_cmd_cfixed_fifo.read();
-        p_vci_ini_config.clen    = m_config_cmd_clen_fifo.read();
-        p_vci_ini_config.trdid   = m_config_cmd_trdid_fifo.read();
-        p_vci_ini_config.pktid   = m_config_cmd_pktid_fifo.read();
-    }
-    else
-    {
-        p_vci_ini_config.cmdval  = false;
-        p_vci_ini_config.address = 0;
-        p_vci_ini_config.be      = 0;
-        p_vci_ini_config.cmd     = vci_param_io::CMD_NOP;
-        p_vci_ini_config.contig  = false;
-        p_vci_ini_config.wdata   = 0;
-        p_vci_ini_config.eop     = false;
-        p_vci_ini_config.cons    = true;
-        p_vci_ini_config.plen    = 0;
-        p_vci_ini_config.wrap    = false;
-        p_vci_ini_config.cfixed  = false;
-        p_vci_ini_config.clen    = 0;
-        p_vci_ini_config.trdid   = 0;
-        p_vci_ini_config.pktid   = 0; 
-    }
+    // VCI initiator response on IOX Network
+    // it depends on the CONFIG_RSP FSM state
+
+   	p_vci_ini_iox.rspack = m_config_rsp_data_fifo.wok() and 
+                           (r_config_rsp_fsm.read() == CONFIG_RSP_FIFO_PUT) and
+                           not r_alloc_fifo_config_rsp_local.read();
+
+    // VCI initiator command  on INT network 
+    // it depends on the MISS_WTI_CMD FSM state
+
+    // default values
+    p_vci_ini_int.srcid   = m_int_srcid;
+    p_vci_ini_int.trdid   = 0;
+    p_vci_ini_int.cfixed  = false;
+    p_vci_ini_int.eop     = true;
+    p_vci_ini_int.wrap    = false;
+    p_vci_ini_int.clen    = 0;
+    p_vci_ini_int.contig  = false;
+    p_vci_ini_int.cons    = true;
+    p_vci_ini_int.be      = 0xFF;
     
-    // VCI target command on the Direct network
-    // it depends on the CONFIG_CMD FSM state
-
-    switch ( r_config_cmd_fsm.read() ) 
-    {
-    case CONFIG_CMD_IDLE:
-    case CONFIG_CMD_TRT_LOCK:   
-    case CONFIG_CMD_TRT_WAIT: 
-    case CONFIG_CMD_TRT_SET: 
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_1:
-    case CONFIG_CMD_IT_ADDR_READ_1:
-    case CONFIG_CMD_ERROR_RSP:  
-    case CONFIG_CMD_INVAL_REQ:
-        p_vci_tgt_config.cmdack  = false;
-        break;
-    case CONFIG_CMD_FIFO_PUT:	  
-    case CONFIG_CMD_PTPR_WRITE:
-    case CONFIG_CMD_PTPR_READ:
-    case CONFIG_CMD_ACTIVE_WRITE:
-    case CONFIG_CMD_ACTIVE_READ:
-    case CONFIG_CMD_BVAR_READ:
-    case CONFIG_CMD_ETR_READ:
-    case CONFIG_CMD_BAD_ID_READ:
-    case CONFIG_CMD_IT_ADDR_IOMMU_WRITE_2:
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_2:
-    case CONFIG_CMD_IT_ADDR_WRITE_2:
-    case CONFIG_CMD_IT_ADDR_READ_2:
-    case CONFIG_CMD_INVAL: 
-        p_vci_tgt_config.cmdack  = m_config_cmd_addr_fifo.wok();
-        break;
-    case CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1:
-    case CONFIG_CMD_IT_ADDR_WRITE_1:
-    case CONFIG_CMD_ERROR_WAIT: 
-        p_vci_tgt_config.cmdack = true; 
-        break;
-    default: 
-        p_vci_tgt_config.cmdack  = false;
-        break;
-    }// end switch r_config_cmd_fsm
-
-    /////////////////////
-    // CONFIG Responses//
-    /////////////////////
+    switch ( r_miss_wti_cmd_fsm.read() ) 
+    {   
+    case MISS_WTI_CMD_IDLE:
+		p_vci_ini_int.cmdval  = false;
+        p_vci_ini_int.address = 0;
+        p_vci_ini_int.cmd     = vci_param_int::CMD_NOP;
+        p_vci_ini_int.pktid   = PKTID_READ;
+        p_vci_ini_int.wdata   = 0;
+        p_vci_ini_int.plen    = 0;
+        break;
     
-    // VCI target response on the Direct network
-    if(r_config_rsp_fifo_local_priority)
-    {
-    if( m_config_local_data_fifo.rok() )
-    {
-        p_vci_tgt_config.rspval  = true;
-		p_vci_tgt_config.rsrcid  = m_config_local_rsrcid_fifo.read();
-        p_vci_tgt_config.rtrdid  = m_config_local_rtrdid_fifo.read();
-        p_vci_tgt_config.rpktid  = m_config_local_rpktid_fifo.read();
-        p_vci_tgt_config.rdata   = (vci_data_t)m_config_local_data_fifo.read();
-        p_vci_tgt_config.rerror  = m_config_local_rerror_fifo.read();
-        p_vci_tgt_config.reop    = m_config_local_reop_fifo.read();
-    }
-    else if(m_config_rsp_data_fifo.rok() )
-    {
-        p_vci_tgt_config.rspval  = true;
-		p_vci_tgt_config.rsrcid  = m_config_rsp_rsrcid_fifo.read();
-        p_vci_tgt_config.rtrdid  = m_config_rsp_rtrdid_fifo.read();
-        
-        p_vci_tgt_config.rpktid  = m_config_rsp_rpktid_fifo.read();
+    case MISS_WTI_CMD_WTI:
+        p_vci_ini_int.cmdval  = true;
+        p_vci_ini_int.address = r_iommu_peri_wti[r_miss_wti_cmd_index.read()].read(); 
+        p_vci_ini_int.cmd     = vci_param_int::CMD_WRITE;
+        p_vci_ini_int.pktid   = PKTID_WRITE;
+        p_vci_ini_int.wdata   = (int_data_t)r_irq_pending[r_miss_wti_cmd_index.read()].read();
+        p_vci_ini_int.plen    = vci_param_int::B;
+        break;
     
-        p_vci_tgt_config.rdata   = (vci_data_t)m_config_rsp_data_fifo.read(); // The first is in param_d
-                                                    // the second in param_io
-        p_vci_tgt_config.rerror  = m_config_rsp_rerror_fifo.read();
-        p_vci_tgt_config.reop    = m_config_rsp_reop_fifo.read();
-    }
-    else
-    {
-        p_vci_tgt_config.rspval  = false;
-        
-		p_vci_tgt_config.rsrcid  = 0;
-		p_vci_tgt_config.rdata   = 0;
-		p_vci_tgt_config.rpktid  = 0;
-		p_vci_tgt_config.rtrdid  = 0;
-		p_vci_tgt_config.rerror  = 0;
-		p_vci_tgt_config.reop    = false;
-
-    }
-    }
-    else
-    {
-    if(m_config_rsp_data_fifo.rok() )
-    {
-        p_vci_tgt_config.rspval  = true;
-		p_vci_tgt_config.rsrcid  = m_config_rsp_rsrcid_fifo.read();
-        p_vci_tgt_config.rtrdid  = m_config_rsp_rtrdid_fifo.read();
-        
-        p_vci_tgt_config.rpktid  = m_config_rsp_rpktid_fifo.read();
-    
-        p_vci_tgt_config.rdata   = (vci_data_t)m_config_rsp_data_fifo.read(); // The first is in param_d
-                                                    // the second in param_io
-        p_vci_tgt_config.rerror  = m_config_rsp_rerror_fifo.read();
-        p_vci_tgt_config.reop    = m_config_rsp_reop_fifo.read();
-    }
-    else if( m_config_local_data_fifo.rok() )
-    {
-        p_vci_tgt_config.rspval  = true;
-		p_vci_tgt_config.rsrcid  = m_config_local_rsrcid_fifo.read();
-        p_vci_tgt_config.rtrdid  = m_config_local_rtrdid_fifo.read();
-        p_vci_tgt_config.rpktid  = m_config_local_rpktid_fifo.read();
-        p_vci_tgt_config.rdata   = (vci_data_t)m_config_local_data_fifo.read();
-        p_vci_tgt_config.rerror  = m_config_local_rerror_fifo.read();
-        p_vci_tgt_config.reop    = m_config_local_reop_fifo.read();
-    }
-    else
-    {
-        p_vci_tgt_config.rspval  = false;
-        
-		p_vci_tgt_config.rsrcid  = 0;
-		p_vci_tgt_config.rdata   = 0;
-		p_vci_tgt_config.rpktid  = 0;
-		p_vci_tgt_config.rtrdid  = 0;
-		p_vci_tgt_config.rerror  = 0;
-		p_vci_tgt_config.reop    = false;
-
-    }
-    }
-    
-    // VCI initiator response on the IO Network
-    // it depends on the CONFIG_RSP FSM state
-    switch ( r_config_rsp_fsm.read() ) 
-    {
-    case CONFIG_RSP_IDLE:
-    case CONFIG_RSP_TRT_LOCK:
-	p_vci_ini_config.rspack = false;
-        break;
-    case CONFIG_RSP_FIFO_PUT:
-		p_vci_ini_config.rspack = m_config_rsp_data_fifo.wok();
-        break;
-    }// end switch r_config_rsp_fsm
-
-    ////////////////////////////////////////////////////////////////
-    // VCI initiator command and response on from the Direct network 
-    // for Miss Transactions
-    p_vci_ini_miss.srcid   = m_srcid_miss;
-    
-    switch ( r_miss_init_fsm.read() ) 
-    {   
-    case MISS_INIT_IDLE_MISS:
-    case MISS_INIT_IDLE_IRQ:
-		p_vci_ini_miss.cmdval  = false;
-        p_vci_ini_miss.address = 0;
-        p_vci_ini_miss.be      = 0;
-        p_vci_ini_miss.cmd     = vci_param_d::CMD_NOP;
-        p_vci_ini_miss.contig  = false;
-        p_vci_ini_miss.wdata   = 0;
-        p_vci_ini_miss.eop     = false;
-        p_vci_ini_miss.cons    = true;
-        p_vci_ini_miss.plen    = 0;
-        p_vci_ini_miss.wrap    = false;
-        p_vci_ini_miss.cfixed  = false;
-        p_vci_ini_miss.clen    = 0;
-        p_vci_ini_miss.trdid   = 0;
-        p_vci_ini_miss.pktid   = 0;
-
-		p_vci_ini_miss.rspack = false;
-        break;
-    
-    case MISS_INIT_IRQ_CMD:
-        p_vci_ini_miss.cmdval  = true;
-        p_vci_ini_miss.address = (paddr_t)r_it_addr[r_irq_chosen.read()]; 
-        p_vci_ini_miss.wdata   = 0;
-        p_vci_ini_miss.plen    = vci_param_d::B;
-        p_vci_ini_miss.trdid   = 0;  
-        p_vci_ini_miss.cmd     = vci_param_d::CMD_READ;
-        p_vci_ini_miss.eop     = true;
-        
-        p_vci_ini_miss.be      = 0xF;
-        p_vci_ini_miss.pktid   = 0;
-        p_vci_ini_miss.cons    = false;
-        p_vci_ini_miss.wrap    = false;
-        p_vci_ini_miss.contig  = true;
-        p_vci_ini_miss.clen    = 0;
-        p_vci_ini_miss.cfixed  = false;
-        break;
-    
-    case MISS_INIT_IRQ_RSP:
-    case MISS_INIT_TLB_MISS_RSP:
-        p_vci_ini_miss.cmdval  = false;
-        p_vci_ini_miss.address = 0;
-        p_vci_ini_miss.be      = 0;
-        p_vci_ini_miss.cmd     = vci_param_d::CMD_NOP;
-        p_vci_ini_miss.contig  = false;
-        p_vci_ini_miss.wdata   = 0;
-        p_vci_ini_miss.eop     = false;
-        p_vci_ini_miss.cons    = true;
-        p_vci_ini_miss.plen    = 0;
-        p_vci_ini_miss.wrap    = false;
-        p_vci_ini_miss.cfixed  = false;
-        p_vci_ini_miss.clen    = 0;
-        p_vci_ini_miss.trdid   = 0;
-        p_vci_ini_miss.pktid   = 0;
-        
-        p_vci_ini_miss.rspack = true;
- 
-        break;
-   
-    case MISS_INIT_TLB_MISS_CMD:
-        p_vci_ini_miss.cmdval  = true;
-        p_vci_ini_miss.address = (paddr_t)((r_iotlb_paddr.read())& CACHE_LINE_MASK);
-        p_vci_ini_miss.wdata   = 0x00000000;
-        p_vci_ini_miss.plen    = m_words*(vci_param_d::B);
-        p_vci_ini_miss.trdid   = 0;  //could be used as the index on a miss transaction table
-        p_vci_ini_miss.cmd     = vci_param_d::CMD_READ;
-        p_vci_ini_miss.eop     = true;
-        
-        p_vci_ini_miss.be      = 0xF;
-        p_vci_ini_miss.pktid   = 0;
-        p_vci_ini_miss.cons    = false;
-        p_vci_ini_miss.wrap    = false;
-        p_vci_ini_miss.contig  = true;
-        p_vci_ini_miss.clen    = 0;
-        p_vci_ini_miss.cfixed  = false;
-        break;
-
-    } // end switch r_miss_init_fsm
+    case MISS_WTI_CMD_MISS:
+        p_vci_ini_int.cmdval  = true;
+        p_vci_ini_int.address = r_tlb_paddr.read() & CACHE_LINE_MASK;
+        p_vci_ini_int.cmd     = vci_param_int::CMD_READ;
+        p_vci_ini_int.pktid   = PKTID_READ;
+        p_vci_ini_int.wdata   = 0;
+        p_vci_ini_int.plen    = m_words*(vci_param_int::B);
+        break;
+    }
+
+    // VCI initiator response on INT network
+    // It depends on the MISS_WTI_RSP FSM state
+
+    if ( r_miss_wti_rsp_fsm.read() == MISS_WTI_RSP_IDLE ) p_vci_ini_int.rspack  = false;
+    else                                                  p_vci_ini_int.rspack  = true;
+
 } // end genMoore
 
